#include "actmap.hh"

void ActMapBase::SetAgentChan(const Agent &ag, const Channel &ch)
{
    unsigned ai = AgentIndex(ag);
    unsigned ci = ChannelIndex(ch);
    
    agchan.Add(make_pair(ai, ci));
}

ActMapBase::~ActMapBase()
{
}

bool ActMapBase::DoMarkOp(unsigned ci, unsigned mi)
{
    bool got = false;
    for(unsigned a=0; a<agchan.Size(); ++a)
    {
        pair<unsigned, unsigned> tmp = agchan[a];
        if(tmp.second == ci)
        {
            Set(tmp.first, ci, mi);
            got = true;
        }
    }
    return got;
}

void ActMapBase::InitMap()
{
    map.clear();
    map.resize(As() * Cs() * Ms());
}

unsigned ActMapBase::MdInd(unsigned a, unsigned c, unsigned m) const
{
    return m + Ms() * (c + Cs() * a);
}

void ActMapBase::Set(unsigned a, unsigned c, unsigned m)
{
    map[MdInd(a, c, m)] = true;
}
